﻿using System;
using System.Collections;
using System.Collections.ObjectModel;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using ThinkGeo.MapSuite.Core;

namespace NavigationHistory
{
    public enum SpatialLayerType : int
    {
        Polygon = 1,
        Line = 2,
        Point = 3,
        Image = 4

    }
    public partial class _Default : System.Web.UI.Page
    {
        protected override void OnInit(EventArgs e)
        {
            //btn.Attributes.Add("onclick","return SelectByRectangle();");
            //btnNext.Attributes.Add("onclick", "return zoomNext();");
            //btnPrev.Attributes.Add("onclick", "return zoomPrev();");
            this.Map1.TrackShapeFinished += new EventHandler(Map1_TrackShapeFinished);
            base.OnInit(e);
        }
        void Map1_TrackShapeFinished(object sender, EventArgs e)
        {
            if (Map1.EditOverlay.Features.Count > 0)
            {
                Feature mainFeature = Map1.EditOverlay.Features[0];
                Layer activeLayer = Map1.StaticOverlay.Layers[0];

                SpatialViewerDetail layerDetails = ((SpatialLayer)Map1.StaticOverlay.Layers[0]).SpatialViewerDetail;
                layerDetails.LayerType = 3;
                SpatialViewerDetail detail = ((SpatialLayer)activeLayer).SpatialViewerDetail;
                //DataTable table = (DataTable)Session[detail.LayerName + "MapTableData"];
                InMemoryFeatureLayer lyr;
                lyr = (InMemoryFeatureLayer)Map1.DynamicOverlay.Layers[layerDetails.SpatialData + "Selections"];
                SpatialLayer tmpLyr = (SpatialLayer)activeLayer;
                Collection<Feature> allFeatures = FindFeaturesByShape(activeLayer, tmpLyr, mainFeature);
                lyr.InternalFeatures.Clear();
                //lyr.FeatureSource.Open();
                //lyr.FeatureSource.BeginTransaction();
                string featureIDs = "";
                foreach (Feature feature in allFeatures)
                {
                    if (featureIDs != "")
                    {
                        featureIDs = featureIDs + ",";
                    }
                    featureIDs = featureIDs + feature.ColumnValues["thinkGeoID"];

                    lyr.InternalFeatures.Add(feature);
                }

            }
            Map1.EditOverlay.Features.Clear();
            Map1.DynamicOverlay.Redraw();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                InitData();
                LoadLayer();
            }
        }
        private Collection<Feature> FindFeaturesByShape(Layer activeLayer, ShapeFileFeatureLayer layer, Feature mainFeature)
        {


            SpatialViewerDetail layerDetails = ((SpatialLayer)activeLayer).SpatialViewerDetail;
            Collection<Feature> allFeatures = new Collection<Feature>();

            layer.Open();
            switch (mainFeature.GetWellKnownType())
            {
                case WellKnownType.Polygon:
                case WellKnownType.Multipolygon:
                    RectangleShape rectangleShape = mainFeature.GetBoundingBox();
                    switch (layerDetails.LayerType)
                    {
                        case (int)SpatialLayerType.Line:
                            allFeatures = layer.QueryTools.GetFeaturesWithin(rectangleShape, ReturningColumnsType.AllColumns);
                            break;
                        case (int)SpatialLayerType.Point:
                            allFeatures = layer.QueryTools.GetFeaturesWithin(rectangleShape, ReturningColumnsType.AllColumns);
                            break;
                        case (int)SpatialLayerType.Polygon:
                            allFeatures = layer.QueryTools.GetFeaturesWithin(rectangleShape, ReturningColumnsType.AllColumns);
                            break;
                    }
                    break;
                case WellKnownType.Line:
                case WellKnownType.Multiline:
                    switch (layerDetails.LayerType)
                    {
                        case (int)SpatialLayerType.Line:
                            allFeatures = layer.QueryTools.GetFeaturesTouching(mainFeature, ReturningColumnsType.AllColumns);
                            break;
                        case (int)SpatialLayerType.Point:
                            allFeatures = layer.QueryTools.GetFeaturesWithin(mainFeature, ReturningColumnsType.AllColumns);
                            break;
                        case (int)SpatialLayerType.Polygon:
                            allFeatures = layer.QueryTools.GetFeaturesIntersecting(mainFeature, ReturningColumnsType.AllColumns);
                            break;
                    }
                    break;
                case WellKnownType.Point:
                case WellKnownType.Multipoint:
                    switch (layerDetails.LayerType)
                    {
                        case (int)SpatialLayerType.Line:
                            allFeatures = layer.QueryTools.GetFeaturesTouching(mainFeature, ReturningColumnsType.AllColumns);
                            break;
                        case (int)SpatialLayerType.Point:
                            allFeatures = layer.QueryTools.GetFeaturesWithin(mainFeature, ReturningColumnsType.AllColumns);
                            break;
                        case (int)SpatialLayerType.Polygon:
                            allFeatures = layer.QueryTools.GetFeaturesIntersecting(mainFeature, ReturningColumnsType.AllColumns);
                            break;
                    }
                    break;


            }





            layer.Close();
            return allFeatures;


        }
        private void InitData()
        {


            Map1.MapTools.LoadingImage.Enabled = true;
            Map1.MapTools.LoadingImage.Width = 64;
            Map1.MapTools.LoadingImage.Height = 64;
            Map1.MapTools.LoadingImage.ImageUri = new Uri(new Uri(Request.Url.AbsoluteUri), "../../images/spatialviewer/loading.gif");
            //Map1.MapTools.LoadingImage.ImageUri = new Uri(Page.ResolveUrl("~/images/spatialviewer/loading.gif"));


            Map1.MapUnit = GeographyUnit.DecimalDegree;




            //Map1.StaticOverlay.ClientCache.CacheId = "InMemoryLayer";


            //Map1.StaticOverlay.ServerCache.CacheDirectory = MapPath("~/Cache/" + Request.Path);



        }
        private void LoadLayer()
        {
            SpatialViewerDetail layer = new SpatialViewerDetail();
            layer.SpatialData = "RoadNetwork.shp";
            layer.ClassColName = "class";
            string layerFileName = MapPath("~/Data/wht5.shp");
            layer.FilePath = layerFileName;
            SpatialLayer tmpLayer = new SpatialLayer(layer, layerFileName);
            tmpLayer.IsVisible = true;
            SpatialInMemoryLayer inMemoryLayer = new SpatialInMemoryLayer(layer);
            Session[tmpLayer.Name + "LAYER"] = layer;


            GeoColor brushCol = GeoColor.FromArgb(255, 255, 0, 0);
            GeoColor outlineColour = GeoColor.FromArgb(255, 0, 255, 0);
            GeoSolidBrush tmpBrush = new GeoSolidBrush(brushCol);
            GeoPen outlinePen = new GeoPen(outlineColour, 10);
            PointStyle pntStyle = new PointStyle();
            pntStyle.SymbolPen = outlinePen;
            pntStyle.SymbolSolidBrush = tmpBrush;
            pntStyle.SymbolSize = Convert.ToInt16(10);
            tmpLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = pntStyle;

            tmpLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

             brushCol = GeoColor.FromArgb(255, 0, 0, 255);
             outlineColour = GeoColor.FromArgb(255, 255, 0, 0);
             tmpBrush = new GeoSolidBrush(brushCol);
            outlinePen = new GeoPen(outlineColour, 10);
            pntStyle = new PointStyle();
            pntStyle.SymbolPen = outlinePen;
            pntStyle.SymbolSolidBrush = tmpBrush;
            pntStyle.SymbolSize = Convert.ToInt16(10);
            inMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = pntStyle;

            inMemoryLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            
            Map1.StaticOverlay.Layers.Add(tmpLayer.SpatialViewerDetail.SpatialData, tmpLayer);
            Map1.DynamicOverlay.Layers.Add(
                                        tmpLayer.SpatialViewerDetail.SpatialData + "Selections", inMemoryLayer);

            Map1.CurrentExtent = new RectangleShape(101.46356375, -8.9084203125, 165.09637625, -43.9767796875);
            

        }
    }
}
